my %fsjointime;

$AMI_Event_Handler{'queuelog'}{'JOIN'} = sub {
    my $event = shift;
    my @allreturn;

    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    my $clid     = ${$event}{'CallerID'}." ".${$event}{'CallerIDName'};
    my $uniq     = ${$event}{'Uniqueid'};
    my $queue    = ${$event}{'Queue'};
    my $tstamp   = time();
    my $agent    = 'NONE';
    my $info1    = '';
    my $info2    = $clid;
    my $info3    = '';
    my $info4    = '';
    my $info5    = '';
    my $event    = 'ENTERQUEUE';

    my $linea = $tstamp."|$uniq|$queue|$agent|$event|$info1|$info2|$info3|$info4|$info5\n";

    $fsjointime{$uniq}=$tstamp;

    open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
    print $fh $linea;
    close $fh;

    #print "$linea";

    return @allreturn;

};

$AMI_Event_Handler{'queuelog'}{'ABANDON'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    my $clid     = ${$event}{'CallerID'}." ".${$event}{'CallerIDName'};
    my $uniq     = ${$event}{'Uniqueid'};
    my $queue    = ${$event}{'Queue'};
    my $waittime = ${$event}{'WaitTime'};
    my $reason   = ${$event}{'Reason'};
    my $tstamp   = time();
    my $agent    = 'NONE';
    my $info1    = '0'; # hangup   position
    my $info2    = '0'; # original position
    my $info3    = $waittime;
    my $info4    = '';
    my $info5    = '';
    my $event    = 'ABANDON';

    if($reason eq 'TIMEOUT') {
        $event = 'EXITWITHTIMEOUT';
    }

    my $linea = $tstamp."|$uniq|$queue|$agent|$event|$info1|$info2|$info3|$info4|$info5\n";

    open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
    print $fh $linea;
    close $fh;

    #print "$linea";

    delete $fsjointime{$uniq};
    return @allreturn;
};


$AMI_Event_Handler{'queuelog'}{'AGENTCONNECT'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;
    # foreach my $key (@keys) {
    #     print "$key = ".${$event}{$key}."\n";
    # }
    # print "\n";

    my $clid     = ${$event}{'CallerID'}." ".${$event}{'CallerIDName'};
    my $uniq     = ${$event}{'Uniqueid'};
    my $queue    = ${$event}{'Queue'};
    my $tstamp   = time();
    my $agent    = ${$event}{'MemberName'};
    my $info1    = ${$event}{'HoldTime'};
    my $info2    = '-'; # uniqueid
    my $info3    = ${$event}{'RingTime'};
    my $info4    = '';
    my $info5    = '';
    my $event    = 'CONNECT';

    if(defined($fsjointime{$uniq})) {
        $info1 = $tstamp - $fsjointime{$uniq};
    }

    my $linea = $tstamp."|$uniq|$queue|$agent|$event|$info1|$info2|$info3|$info4|$info5\n";

    open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
    print $fh $linea;
    close $fh;

    # print "$linea";

    delete $fsjointime{$uniq};
    return @allreturn;

};

$AMI_Event_Handler{'queuelog'}{'AGENTCOMPLETE'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    my $clid     = ${$event}{'CallerID'}." ".${$event}{'CallerIDName'};
    my $uniq     = ${$event}{'Uniqueid'};
    my $queue    = ${$event}{'Queue'};
    my $tstamp   = time();
    my $agent    = ${$event}{'MemberName'};
    my $info1    = ${$event}{'WaitTime'};
    my $info2    = ${$event}{'TalkTime'};
    my $info3    = 1; #ORIGINAL POSITION
    my $info4    = '';
    my $info5    = '';
    my $event    = 'COMPLETECALLER';

    my $linea = $tstamp."|$uniq|$queue|$agent|$event|$info1|$info2|$info3|$info4|$info5\n";

    open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
    print $fh $linea;
    close $fh;

    #print "$linea";

    delete $fsjointime{$uniq};
    return @allreturn;


};

$AMI_Event_Handler{'queuelog'}{'AGENTRINGNOANSWER'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    my $clid     = ${$event}{'CallerID'}." ".${$event}{'CallerIDName'};
    my $uniq     = ${$event}{'Uniqueid'};
    my $queue    = ${$event}{'Queue'};
    my $tstamp   = time();
    my $agent    = ${$event}{'MemberName'};
    my $info1    = ${$event}{'RingTime'} * 1000;
    my $info2    = '';
    my $info3    = '';
    my $info4    = '';
    my $info5    = '';
    my $event    = 'RINGNOANSWER';

    my $linea = $tstamp."|$uniq|$queue|$agent|$event|$info1|$info2|$info3|$info4|$info5\n";

    open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
    print $fh $linea;
    close $fh;

    #print "$linea";

    return @allreturn;

};
